#!/bin/tcsh

# Get new hypoinverse delay files from Fred Klein's FTP site 

cd hypoinverse/models
echo "getting new files in hypoinverse/models"

if ( ! -d NEW) mkdir NEW
cd NEW

wget ftp://ehzftp.wr.usgs.gov/klein/crust-models/\*3.del
wget ftp://ehzftp.wr.usgs.gov/klein/crust-models/multmod2.alt
chmod u+w *
cd ..

set missed = 0
foreach file (*3.del multmod2.alt) 
    if ( -f $file ) then
	mv $file $file.0
    endif
    if ( -f NEW/$file ) then
	mv NEW/$file $file
    else
	echo failed to get new $file
	set missed = 1
    endif
end
# Unless there are new delay files, NEW should be empty now
cd NEW
set nonomatch
set files = `ls`;
if ("x$files" != "x") then
    foreach file (*)
	echo "New delay file: $file"
	mv $file ..
    end
endif

if ( $missed == 1 ) then
    echo "Some files missing!"
    exit 1
endif

echo Make new bin files with "./makebinary"

