#!/bin/tcsh

# Get new hypoinverse files from Fred Klein's FTP site 
# and make new hypoinverse binary files

cd hypoinverse/hypfiles
echo "getting new files in hypoinverse/hypfiles"

set base_url="ftp://ehzftp.wr.usgs.gov/klein"
set hypfiles = "all2000seed.cal all2000seed.fmc all2000seed.xmc allseed.sta"

set missed = 0
foreach file ($hypfiles) 
    if ( -f $file ) then
	mv $file $file.0
    endif
    wget "$base_url/hypfiles/$file"
    if ( ! -f $file ) then
	echo failed to get new $file
	set missed = 1
    endif
end

if ( $missed == 1 ) then
    echo "Some files missing!"
    exit 1
endif

echo Make new bin files with "./makebinary"

